<?php

include '../../core.php';

checkAuth($raUrl);

cabecera (2);

$command = $_POST ["csr_command"];

switch ( $command ) {

   default:
 
      $exportType = $_GET["type"];
  
      // Tenemos que ver que vamos a exportar (csrs, csrs y crrs pendientes de
      // ser exportadas, o certificados, revocaciones o solicitudes rechazadas)
      if ( $exportType == "csr" ) {
         echo "<h1 class='title'>Exportaci&oacute;n de las solicitudes a la Autoridad de Certificaci&oacute;n $caName</h1>
         <h3> CSRs que se van a enviar a la CA </h3>
         <br/>\n";

         $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaId=$raNum*)(pkirisStatus=approved))";
      }

      else if ( $exportType == "ra2ca_pending" ) {
         echo "<h1 class='title'>Solicitudes de certificados pendientes de ser enviados a la CA</h1><br/>\n";

         // Nos traemos el numero copa, el identificador y la fecha de las 
         // solicitudes y de las revocaciones pendientes de ser enviadas a la CA
         $filter = "(&(objectClass=pkirisCertificate)(|(pkirisStatus=approved)(pkirisStatus=revoke))";
      }
      else if ( $exportType == "ca2ra_pending" ) {
         echo "<h1 class='title'>Certificados pendientes de ser enviados a la CA</h1><br/>\n";

         // Nos traemos el numero copa, el identificador y la fecha de los 
         // certificados emitidos y revocados, y de las solicitudes rechazadas
         // pendientes de ser enviadas a la RA
         $filter = "(&(objectClass=pkirisCertificate)(|(pkirisStatus=issued)(pkirisStatus=revoked*)(pkirisStatus=*refused))";	   
      }	   
         
      $justthese = array ("pkirisid","pkiriscopaid","pkirisdate");
      $result = ldap_get_info($base,$filter,$justthese);

      if ($result["count"] == 0) {
         echo "<h3> No hay peticiones Nuevas </h3>";
      }
      else {
         echo "<table border='1' cellpadding='2' cellspacing='0'>
         <tr><th>C&oacute;digo de Solicitud</th><th>Identificador</th><th>Fecha</th></tr>
         <form method='post' action='csr_export.php' enctype='multipart/form-data' name='csr_makeXml'>\n";
         for($i = 0; $i < $result["count"]; $i++) {
            $copa = $result[$i]["pkiriscopaid"][0];
            $ident = $result[$i]["pkirisid"][0];
            $anio = substr($result[$i]["pkirisdate"][0], 0, 4);
            $mes = substr($result[$i]["pkirisdate"][0], 4, 2);
            $dia = substr($result[$i]["pkirisdate"][0], 6, 2);
            $hora = substr($result[$i]["pkirisdate"][0], 8, 2);
            $minuto = substr($result[$i]["pkirisdate"][0], 10, 2);
            $segundo = substr($result[$i]["pkirisdate"][0], 12, 2);
            $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
   
            echo "<tr><td><a href='csr_manage_export.php?copa=$copa?$ident?$fecha'>". $copa ." </a></td><td> $ident </td><td> ". $fecha ."  </td></tr>
            <input type='hidden' name='pkiId$i' value='$copa'>\n";
         }
         echo "</table>
         <br/>
         <input type='hidden' name='cantId' value='$i'>
         <input type='hidden' name='csr_command' value='make_xml'>
         <input type='submit' value='Enviar a la CA' />
         </form>\n";
      }
   
   break;

   case "make_xml": //Crea la solicitud para exportar a la CA o a la RA en xml
      $cant = $_POST["cantId"];

      echo "<h1 class='title'>Exportaci&oacute;n de las solicitudes a la Autoridad de Cetificaci&oacute;n $caName</h1>
  	    <h3> Hay $cant CSRs que se van a enviar a la CA </h3>\n";
	
      // En primer lugar generamos el fichero XML que servira para enviar los
      // datos a la CA. Necesitaremos un array con los codigos copa de todas
      // las solicitudes que se van a exportar
      $copasArray = array ();
      for ($i = 0; $i < $cant; $i++) {
         $copa = $_POST["pkiId$i"];
	 $lastStatus = getStatus($copa);
         if ( $lastStatus == "revoke")
	    $xmlString = createXML ( $copa );
         else 	 
            $r= array_push( $copasArray, $copa);
      }
	   
      // Generamos el fichero y guardamos el codigo XML en una variable
      $xmlString = createXML ( $copasArray );
      if ( !$xmlString ) {
         $errorNumber = 69;
	 $errorCounter++;


	 $errorDescription = "\n<p>No ha sido posible generar el fichero XML.</p>\n";
      
      }
	
      // Si no ha habido ningun error,
      if ( $errorCounter == 0 ) {
         // enviamos un mail al administrador con la CSR
         $envioMail = mail($admCaMail, "CSR Aprobada", "Se ha generado un archivo de exportaci&oacute;n con $cant CSRs para ser firmadas por la CA.");
         echo "\n<p>La exportaci&oacute;n de las CSRs se ha efectuado con &eacute;xito.</p>\n";
      }
      else 
         echo "<h3>Error en la exportaci&oacute;n de las solicitudes</h3>" . $errorDescription;
	
 
      // Obtenemos el pkirisCopaID a partir de pkirisSubjectID
      $userDN = $_SESSION['user'];
      $filter = "(&(objectClass=pkirisCertificate)(pkirisSubjectDn=$userDN)(pkirisStatus=issued))";
      $justthese = array("pkirisCopaID");
      $result = ldap_get_info($base, $filter, $justthese);

      $user = $result[0]['pkiriscopaid'][0];				    
      $status = $lastStatus = getStatus($copa);

      writeLog ($status, $copa, $user, $errorNumber);

      break;

}

pie ();
	
?>
