<?php

$exportType = $_GET["type"];

if ( $exportType == "ra2ca_pending" ) {
   $core = '../../core.php';
   $n = 2;
}

else if ( $exportType == "ca2ra_pending" ) {
   $core = '../core.php';
   $n = 4;
}
include $core;

checkAuth($raUrl);

cabecera ($n);

$command = $_POST ["csr_command"];

switch ( $command ) {

   default:
      // Tenemos que ver que vamos a exportar (csrs y crrs pendientes de
      // ser exportadas, o certificados, revocaciones y solicitudes rechazadas)
      if ( $exportType == "ra2ca_pending" ) {
         $elementsType = "Solicitudes de certificados y/o de revocaci&oacute;n de certificados";	 
	 $destHost = "CA";
         // Nos traemos el numero copa, el identificador y la fecha de las 
         // solicitudes y de las revocaciones pendientes de ser enviadas a la CA
         $filter = "(&(objectClass=pkirisCertificate)(pkirisCopaId=$raNum*)(|(pkirisStatus=approved)(pkirisStatus=revoke)))";
      }
      else if ( $exportType == "ca2ra_pending" ) {
         $elementsType = "Certificados, revocaciones y/o solicitudes rechazadas";
         $destHost = "RA";
         // Nos traemos el numero copa, el identificador y la fecha de los 
         // certificados emitidos y revocados, y de las solicitudes rechazadas
         // pendientes de ser enviadas a la RA
         $filter = "(&(objectClass=pkirisCertificate)(|(pkirisStatus=issued)(pkirisStatus=revoked*)(pkirisStatus=*refused)))";	   
      }	   
         
      echo "<h1 class='title'>$elementsType pendientes de ser enviados a la $destHost</h1><br/>\n";
      
      $justthese = array ("pkirisid","pkiriscopaid","pkirisdate", "pkirisstatus");
      $result = ldap_get_info($base,$filter,$justthese);

      if ($result["count"] == 0) {
         echo "<h2>No hay peticiones Nuevas</h2>";
      }
      else {
         echo "<table border='1' cellpadding='2' cellspacing='0'>
         <tr><th>C&oacute;digo de Solicitud</th><th>Identificador</th><th>Fecha</th><th>Estado</th></tr>
         <form method='post' action='data_export.php?sessionID=$sessionID&type=$exportType' enctype='multipart/form-data' name='csr_makeXml'>\n";
         for($i = 0; $i < $result["count"]; $i++) {
            $copa = $result[$i]["pkiriscopaid"][0];
            $ident = $result[$i]["pkirisid"][0];
            $anio = substr($result[$i]["pkirisdate"][0], 0, 4);
            $mes = substr($result[$i]["pkirisdate"][0], 4, 2);
            $dia = substr($result[$i]["pkirisdate"][0], 6, 2);
            $hora = substr($result[$i]["pkirisdate"][0], 8, 2);
            $minuto = substr($result[$i]["pkirisdate"][0], 10, 2);
            $segundo = substr($result[$i]["pkirisdate"][0], 12, 2);
            $fecha = $dia."/".$mes."/".$anio." - ".$hora.":".$minuto.":".$segundo;
	    $status = $result[$i]["pkirisstatus"][0];
            echo "<tr><td><a href='csr_manage_export.php?copa=$copa?$ident?$fecha'>$copa</a></td><td>$ident</td><td>$fecha</td><td>$status</td></tr>
            <input type='hidden' name='pkiId$i' value='$copa'>\n";
         }
         echo "</table>
         <br/>
         <input type='hidden' name='cantId' value='$i'>
         <input type='hidden' name='csr_command' value='make_xml'>
	 <input type='hidden' name='elementsType' value='$elementsType'>
	 <input type='hidden' name='destHost' value='$destHost'>
         <input type='submit' value='Enviar a la CA' />
         </form>\n";
      }
   
   break;

   case "make_xml": //Crea la solicitud para exportar a la CA o a la RA en xml
      $cant = $_POST["cantId"];

      echo "<h1 class='title'>Exportaci&oacute;n de las solicitudes a la $destHost</h1>
            <h3> Hay $cant $elementsType que se van a enviar a la $destHost </h3>\n";
      
      // En primer lugar generamos el fichero XML que servira para enviar los
      // datos a la CA. Necesitaremos un array con los codigos copa de todas
      // las solicitudes que se van a exportar
      $copasArray = array ();
      for ($i = 0; $i < $cant; $i++) {
         $copa = $_POST["pkiId$i"];
	 $status = getStatus($copa);
	 array_push( $copasArray, $copa);
         if ( $status == "revoke") {
	    // Las revocaciones pendientes las exportaremos de una en una,
	    $xmlString = createXML ( $copasArray );
	    // por lo que una vez generado el XML, la sacamos del array
	    array_pop( $copasArray );	    
	 }
      }
	   
      // Generamos el fichero y guardamos el codigo XML en una variable, 
      // si al menos hay una solicitud/certificado a exportar
      if ( $copasArray != null ) 
         $xmlString = createXML ( $copasArray );
	 
      if ( !$xmlString ) {
         $errorNumber = 69;
	 $errorCounter++;
	 $errorDescription = "\n<p>No ha sido posible generar el fichero XML.</p>\n";
      }
	
      // Si no ha habido ningun error,
      if ( $errorCounter == 0 ) {
         // enviamos un mail al administrador con la CSR
         $envioMail = mail($admCaMail, "CSR Aprobada", "Se ha generado un archivo de exportaci&oacute;n con $cant $elementsType para ser enviadas a la $destHost\n\n\n$xmlString");
         echo "\n<p>La exportaci&oacute;n se ha efectuado con &eacute;xito.</p>\n";
      }
      else 
         echo "<h3>Error en la exportaci&oacute;n.</h3>" . $errorDescription;

      
      // Obtenemos el pkirisCopaID a partir de pkirisSubjectID
      $userDN = $_SESSION['user'];
      $filter = "(&(objectClass=pkirisCertificate)(pkirisSubjectDn=$userDN)(pkirisStatus=issued))";
      $justthese = array("pkirisCopaID");
      $result = ldap_get_info($base, $filter, $justthese);

      $user = $result[0]['pkiriscopaid'][0];
      $lastStatus = getStatus($copa);
      
      writeLog ($lastStatus, $copa, $user, $errorNumber);

      break;

}

pie ();
	
?>
